//
// TeamMembers.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct TeamMembers: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var memberKeyNumeric: Double?
    public var teamKeyNumeric: Double?
    public var teamMemberKeyNumeric: Double?
    public var memberKey: String?
    public var memberLoginId: String?
    public var memberMlsId: String?
    public var originatingSystemID: Double?
    public var originatingSystemKey: String?
    public var originatingSystemName: String?
    public var sourceSystemID: Double?
    public var sourceSystemKey: String?
    public var sourceSystemName: String?
    public var teamKey: String?
    public var teamMemberKey: String?
    public var teamMemberNationalAssociationId: String?
    public var teamMemberStateLicense: String?
    public var teamImpersonationLevel: String?
    public var teamMemberType: String?
    public var modificationTimestamp: Date?
    public var originalEntryTimestamp: Date?
    public var member: Member?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?

    public init(id: Int? = nil, memberKeyNumeric: Double? = nil, teamKeyNumeric: Double? = nil, teamMemberKeyNumeric: Double? = nil, memberKey: String? = nil, memberLoginId: String? = nil, memberMlsId: String? = nil, originatingSystemID: Double? = nil, originatingSystemKey: String? = nil, originatingSystemName: String? = nil, sourceSystemID: Double? = nil, sourceSystemKey: String? = nil, sourceSystemName: String? = nil, teamKey: String? = nil, teamMemberKey: String? = nil, teamMemberNationalAssociationId: String? = nil, teamMemberStateLicense: String? = nil, teamImpersonationLevel: String? = nil, teamMemberType: String? = nil, modificationTimestamp: Date? = nil, originalEntryTimestamp: Date? = nil, member: Member? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil) {
        self.id = id
        self.memberKeyNumeric = memberKeyNumeric
        self.teamKeyNumeric = teamKeyNumeric
        self.teamMemberKeyNumeric = teamMemberKeyNumeric
        self.memberKey = memberKey
        self.memberLoginId = memberLoginId
        self.memberMlsId = memberMlsId
        self.originatingSystemID = originatingSystemID
        self.originatingSystemKey = originatingSystemKey
        self.originatingSystemName = originatingSystemName
        self.sourceSystemID = sourceSystemID
        self.sourceSystemKey = sourceSystemKey
        self.sourceSystemName = sourceSystemName
        self.teamKey = teamKey
        self.teamMemberKey = teamMemberKey
        self.teamMemberNationalAssociationId = teamMemberNationalAssociationId
        self.teamMemberStateLicense = teamMemberStateLicense
        self.teamImpersonationLevel = teamImpersonationLevel
        self.teamMemberType = teamMemberType
        self.modificationTimestamp = modificationTimestamp
        self.originalEntryTimestamp = originalEntryTimestamp
        self.member = member
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case memberKeyNumeric = "MemberKeyNumeric"
        case teamKeyNumeric = "TeamKeyNumeric"
        case teamMemberKeyNumeric = "TeamMemberKeyNumeric"
        case memberKey = "MemberKey"
        case memberLoginId = "MemberLoginId"
        case memberMlsId = "MemberMlsId"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemKey = "OriginatingSystemKey"
        case originatingSystemName = "OriginatingSystemName"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemKey = "SourceSystemKey"
        case sourceSystemName = "SourceSystemName"
        case teamKey = "TeamKey"
        case teamMemberKey = "TeamMemberKey"
        case teamMemberNationalAssociationId = "TeamMemberNationalAssociationId"
        case teamMemberStateLicense = "TeamMemberStateLicense"
        case teamImpersonationLevel = "TeamImpersonationLevel"
        case teamMemberType = "TeamMemberType"
        case modificationTimestamp = "ModificationTimestamp"
        case originalEntryTimestamp = "OriginalEntryTimestamp"
        case member = "Member"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(memberKeyNumeric, forKey: .memberKeyNumeric)
        try container.encodeIfPresent(teamKeyNumeric, forKey: .teamKeyNumeric)
        try container.encodeIfPresent(teamMemberKeyNumeric, forKey: .teamMemberKeyNumeric)
        try container.encodeIfPresent(memberKey, forKey: .memberKey)
        try container.encodeIfPresent(memberLoginId, forKey: .memberLoginId)
        try container.encodeIfPresent(memberMlsId, forKey: .memberMlsId)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemKey, forKey: .originatingSystemKey)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemKey, forKey: .sourceSystemKey)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(teamKey, forKey: .teamKey)
        try container.encodeIfPresent(teamMemberKey, forKey: .teamMemberKey)
        try container.encodeIfPresent(teamMemberNationalAssociationId, forKey: .teamMemberNationalAssociationId)
        try container.encodeIfPresent(teamMemberStateLicense, forKey: .teamMemberStateLicense)
        try container.encodeIfPresent(teamImpersonationLevel, forKey: .teamImpersonationLevel)
        try container.encodeIfPresent(teamMemberType, forKey: .teamMemberType)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(originalEntryTimestamp, forKey: .originalEntryTimestamp)
        try container.encodeIfPresent(member, forKey: .member)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
    }
}

